import _Set from "@babel/runtime-corejs3/core-js-stable/set";
import { isSet } from 'lodash-es';
export function copySet(setA) {
  return new _Set(setA);
}
/**
 * Set deduplicate
 * @param {*} setA
 * @param {*} setB
 */

export function pullAll(setA, setB) {
  if (setA === setB) {
    setB = copySet(setB);
  }

  if (isSet(setA) && setA.size && isSet(setB) && setB.size) {
    for (const item of setB) {
      if (setA.has(item)) {
        setA.delete(item);
      }
    }

    return setA;
  }

  return setA;
}